---
id: cli-reference
title: CLI --help
sidebar_label: CLI --help
---

<!-- This file was generated by bloop.util.CommandsDocGenerator (see developer docs) -->

## `bloop about`

#### Usage

<dl>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
</dl>


## `bloop autocomplete`

#### Usage

<dl>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
  <dt><code>--mode</code> (type: <code>mode</code>)</dt>
  <dt><code>--format</code> (type: <code>"bash" | "zsh" | "fish"</code>)</dt>
  <dt><code>--command</code> (type: <code>string?</code>)</dt>
  <dt><code>--project</code> (type: <code>string?</code>)</dt>
</dl>


## `bloop bsp`

#### Usage

<dl>
  <dt><code>--protocol</code> (type: <code>protocol</code>)</dt>
  <dd><p>The connection protocol for the bsp server. By default, local.</p></dd>
  <dt><code>--host</code> (type: <code>string</code>)</dt>
  <dd><p>The server host for the bsp server (TCP only).</p></dd>
  <dt><code>--port</code> (type: <code>int</code>)</dt>
  <dd><p>The port for the bsp server (TCP only).</p></dd>
  <dt><code>--socket</code> (type: <code>path?</code>)</dt>
  <dd><p>A path to a socket file to communicate through Unix sockets (local only).</p></dd>
  <dt><code>--pipe-name</code> (type: <code>string?</code>)</dt>
  <dd><p>A path to a new existing socket file to communicate through Unix sockets (local only).</p></dd>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
</dl>


## `bloop clean`

#### Usage

<dl>
  <dt><code>--projects</code> or <code>-p</code> or <code>--project</code> (type: <code>string*</code>)</dt>
  <dd><p>The projects to clean (you can specify multiple). If none, all are cleaned.</p></dd>
  <dt><code>--include-dependencies</code> or <code>--propagate</code> (type: <code>bool</code>)</dt>
  <dd><p>Clean a project and all its dependencies. By default, false.</p></dd>
  <dt><code>--cascade</code> (type: <code>bool</code>)</dt>
  <dd><p>Clean a project and all projects depending on it. By default, false.</p></dd>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
</dl>

#### Examples

  * <samp>bloop clean</samp>
  * <samp>bloop clean foobar</samp>
  * <samp>bloop clean foobar baz</samp>
  * <samp>bloop clean foobar --propagate</samp>

## `bloop compile`

#### Usage

<dl>
  <dt><code>--projects</code> or <code>-p</code> or <code>--project</code> (type: <code>string*</code>)</dt>
  <dd><p>The projects to compile (will be inferred from remaining cli args).</p></dd>
  <dt><code>--incremental</code> (type: <code>bool</code>)</dt>
  <dd><p>Compile the project incrementally. By default, true.</p></dd>
  <dt><code>--pipeline</code> (type: <code>bool</code>)</dt>
  <dd><p>Pipeline the compilation of modules in your build. By default, false.</p></dd>
  <dt><code>--reporter</code> (type: <code>reporter</code>)</dt>
  <dd><p>Pick reporter to show compilation messages. By default, bloop's used.</p></dd>
  <dt><code>--watch</code> or <code>-w</code> (type: <code>bool</code>)</dt>
  <dd><p>Run the command when projects' source files change. By default, false.</p></dd>
  <dt><code>--cascade</code> (type: <code>bool</code>)</dt>
  <dd><p>Compile a project and all projects depending on it. By default, false.</p></dd>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
</dl>

#### Examples

  * <samp>bloop compile foobar</samp>
  * <samp>bloop compile foobar --cascade</samp>
  * <samp>bloop compile foobar baz</samp>
  * <samp>bloop compile foobar -w</samp>
  * <samp>bloop compile foobar --reporter bloop</samp>
  * <samp>bloop compile foobar --reporter scalac</samp>

## `bloop configure`

#### Usage

<dl>
  <dt><code>--threads</code> (type: <code>int</code>)</dt>
  <dd><p>(deprecated) Set the number of threads used to compile and test all projects.</p></dd>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
</dl>


## `bloop console`

#### Usage

<dl>
  <dt><code>--projects</code> or <code>-p</code> or <code>--project</code> (type: <code>string*</code>)</dt>
  <dd><p>The projects to run the console at (will be inferred from remaining cli args).</p></dd>
  <dt><code>--incremental</code> (type: <code>bool</code>)</dt>
  <dd><p>Compile the project incrementally. By default, true.</p></dd>
  <dt><code>--pipeline</code> (type: <code>bool</code>)</dt>
  <dd><p>Pipeline the compilation of modules in your build. By default, false.</p></dd>
  <dt><code>--reporter</code> (type: <code>reporter</code>)</dt>
  <dd><p>Pick reporter to show compilation messages. By default, bloop's used.</p></dd>
  <dt><code>--exclude-root</code> (type: <code>bool</code>)</dt>
  <dd><p>Start up the console compiling only the target project's dependencies.</p></dd>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
</dl>

#### Examples

  * <samp>bloop console foobar</samp>
  * <samp>bloop console foobar --exclude-root</samp>

## `bloop help`

#### Usage

<dl>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
</dl>


## `bloop link`

#### Usage

<dl>
  <dt><code>--projects</code> or <code>--project</code> or <code>-p</code> (type: <code>string*</code>)</dt>
  <dd><p>The projects to link (will be inferred from remaining cli args).</p></dd>
  <dt><code>--main</code> or <code>-m</code> (type: <code>string?</code>)</dt>
  <dd><p>The main class to link. Leave unset to let bloop select automatically.</p></dd>
  <dt><code>--incremental</code> (type: <code>bool</code>)</dt>
  <dd><p>Compile the project incrementally. By default, true.</p></dd>
  <dt><code>--pipeline</code> (type: <code>bool</code>)</dt>
  <dd><p>Pipeline the compilation of modules in your build. By default, false.</p></dd>
  <dt><code>--reporter</code> (type: <code>reporter</code>)</dt>
  <dd><p>Pick reporter to show compilation messages. By default, bloop's used.</p></dd>
  <dt><code>--watch</code> or <code>-w</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, run the command whenever projects' source files change.</p></dd>
  <dt><code>--optimize</code> or <code>-O</code> (type: <code>"debug" | "release"?</code>)</dt>
  <dd><p>Optimization level of the linker. Valid options: `debug` or `release` mode. Defaults to `debug`.</p></dd>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
</dl>

#### Examples

  * <samp>bloop link foobar</samp>
  * <samp>bloop link foobar --main com.acme.Main</samp>
  * <samp>bloop link foobar -O debug -w</samp>
  * <samp>bloop link foobar -O release -w</samp>
  * <samp>bloop link foobar --main com.acme.Main -w</samp>

## `bloop projects`

#### Usage

<dl>
  <dt><code>--dot-graph</code> (type: <code>bool</code>)</dt>
  <dd><p>Print out a dot graph you can pipe into `dot`. By default, false.</p></dd>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
</dl>

#### Examples

  * <samp>bloop projects</samp>
  * <samp>bloop projects --dot-graph</samp>

## `bloop run`

#### Usage

<dl>
  <dt><code>--projects</code> or <code>-p</code> or <code>--project</code> (type: <code>string*</code>)</dt>
  <dd><p>The projects to run (will be inferred from remaining cli args).</p></dd>
  <dt><code>--main</code> or <code>-m</code> (type: <code>string?</code>)</dt>
  <dd><p>The main class to run. Leave unset to let bloop select automatically.</p></dd>
  <dt><code>--incremental</code> (type: <code>bool</code>)</dt>
  <dd><p>Compile the project incrementally. By default, true.</p></dd>
  <dt><code>--pipeline</code> (type: <code>bool</code>)</dt>
  <dd><p>Pipeline the compilation of modules in your build. By default, false.</p></dd>
  <dt><code>--reporter</code> (type: <code>reporter</code>)</dt>
  <dd><p>Pick reporter to show compilation messages. By default, bloop's used.</p></dd>
  <dt><code>--args</code> (type: <code>string*</code>)</dt>
  <dd><p>The arguments to pass in to the main class.</p></dd>
  <dt><code>--watch</code> or <code>-w</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, run the command whenever projects' source files change.</p></dd>
  <dt><code>--skip-jargs</code> (type: <code>bool</code>)</dt>
  <dd><p>Ignore arguments starting with `-J` and forward them instead.</p></dd>
  <dt><code>--optimize</code> or <code>-O</code> (type: <code>"debug" | "release"?</code>)</dt>
  <dd><p>If an optimizer is used (e.g. Scala Native or Scala.js), run it in `debug` or `release` mode. Defaults to `debug`.</p></dd>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
</dl>

#### Examples

  * <samp>bloop run foobar</samp>
  * <samp>bloop run foobar -m com.acme.Main -- -J-Xmx4g arg1 arg2</samp>
  * <samp>bloop run foobar -O debug -- arg1</samp>
  * <samp>bloop run foobar -m com.acme.Main -O release -w</samp>

## `bloop test`

#### Usage

<dl>
  <dt><code>--projects</code> or <code>-p</code> or <code>--project</code> (type: <code>string*</code>)</dt>
  <dd><p>The projects to test (will be inferred from remaining cli args).</p></dd>
  <dt><code>--include-dependencies</code> or <code>--propagate</code> (type: <code>bool</code>)</dt>
  <dd><p>Test a project and all its dependencies. By default, false.</p></dd>
  <dt><code>--cascade</code> (type: <code>bool</code>)</dt>
  <dd><p>Test a project and all projects depending on it. By default, false.</p></dd>
  <dt><code>--incremental</code> (type: <code>bool</code>)</dt>
  <dd><p>Compile the project incrementally. By default, true.</p></dd>
  <dt><code>--pipeline</code> (type: <code>bool</code>)</dt>
  <dd><p>Pipeline the compilation of modules in your build. By default, false.</p></dd>
  <dt><code>--only</code> or <code>-o</code> (type: <code>string*</code>)</dt>
  <dd><p>The list of test suite filters to test for only.</p></dd>
  <dt><code>--args</code> (type: <code>string*</code>)</dt>
  <dd><p>The arguments to pass in to the test framework.</p></dd>
  <dt><code>--reporter</code> (type: <code>reporter</code>)</dt>
  <dd><p>Pick reporter to show compilation messages. By default, bloop's used.</p></dd>
  <dt><code>--watch</code> or <code>-w</code> (type: <code>bool</code>)</dt>
  <dd><p>Run the command when projects' source files change. By default, false.</p></dd>
  <dt><code>--config-dir</code> or <code>-c</code> (type: <code>path?</code>)</dt>
  <dd><p>File path to the bloop config directory, defaults to `.bloop` in the current working directory.</p></dd>
  <dt><code>--version</code> or <code>-v</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print the about section at the beginning of the execution. Defaults to false.</p></dd>
  <dt><code>--verbose</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, print out debugging information to stderr. Defaults to false.</p></dd>
  <dt><code>--no-color</code> (type: <code>bool</code>)</dt>
  <dd><p>If set, do not color output. Defaults to false.</p></dd>
  <dt><code>--debug</code> (type: <code>"all" | "file-watching" | "compilation" | "test" | "bsp" | "link"*</code>)</dt>
  <dd><p>Debug the execution of a concrete task.</p></dd>
</dl>

#### Examples

  * <samp>bloop test foobar</samp>
  * <samp>bloop test foobar --cascade</samp>
  * <samp>bloop test foobar baz</samp>
  * <samp>bloop test foobar -w</samp>
  * <samp>bloop test foobar --propagate</samp>
  * <samp>bloop test foobar --propagate -w</samp>
  * <samp>bloop test foobar --only com.acme.StringSpecification</samp>
  * <samp>bloop test foobar --only com.acme.StringSpecification -- -J-Xmx4g</samp>