# bloop `v1.2.5` :surfer:

## Upgrade guide :electric_plug:

This section describes the upgrade steps. If you don't have bloop installed, please read
the [installation instructions][] instead.

If you're on macOS, **upgrade** to the latest version with:

```sh
$ brew upgrade scalacenter/bloop/bloop
$ brew services restart bloop
```

If you're on Windows using `scoop`, **upgrade** to the latest version with:

```sh
$ scoop upgrade bloop
$ bloop ng-stop
$ // Start the server as you usually do (via systemd, manually, desktop services)
```

Otherwise, run:

```
$ curl -L https://github.com/scalacenter/bloop/releases/download/v1.2.5/install.py | python
$ bloop ng-stop
$ // Start the server as you usually do (via systemd, manually, desktop services)
```

Read the complete installation instructions in our [Installation page][installation instructions].

## Highlights :books:

`v1.2.5` is only a bugfix release.

### Report diagnostics better via BSP

Fix clearing of missing diagnostics when previous incremental compiler cycles
have failed, see https://github.com/scalacenter/bloop/issues/804 for more
information.

## Contributors :busts_in_silhouette:

According to `git shortlog -sn --no-merges v1.2.4..v1.2.5`, 1 people contributed to this `v1.2.5`
release: Jorge Vicente Cantero.

[installation instructions]: https://scalacenter.github.io/bloop/setup